// No Damage RJ
//   by Cerapter

//Check for version
if VERSION != 27200
{
	if show_question("Warning! The No Damage RJ was made for Gang Garrison 2 v2.7.2 and you have "+string(GAME_VERSION_STRING)+". This might cause some problems during the game.##Do you wish to proceed anyway?") {
		// Do nothing
	}
	else {
		game_end();
	}
}

// Is it a rocketjumping map? (Does its name start with "rj"?)
// Or SJ (scoutjump) or DJ (detojump). Because why not.
if object_index == Client {checkMap = string_copy(string(downloadMapName),0,2)};
if object_index == GameServer {checkMap = string_copy(string(global.currentMap),0,2)};

if checkMap == "rj" or checkMap == "sj" or checkMap == "dj"
{

//We do not want the characters to be able to hit eachother with rockets
object_event_clear(Rocket,ev_collision,Character)
object_event_add(Rocket,ev_collision,Character,"
if (ds_list_find_index(playersPassed, other.player) == -1 and other.player != ownerPlayer)
    {
        ds_list_add(playersPassed, other.player);
        distanceToTravel -= 100;
    }
")

//Ignore everybody but the owner when dealing pushback and damage is needed
object_event_clear(Rocket,ev_other,ev_user5)
object_event_add(Rocket,ev_other,ev_user5,"
{  
    if(characterHit.id != ownerPlayer.object)
    {
        if(exploded)
            exit;
        else
            exploded = true;
			
        instance_create(x,y,Explosion);
        playsound(x,y,ExplosionSnd);
        
        with (Character) {
            if (distance_to_object(other) < other.blastRadius and !(team == other.team and id != other.ownerPlayer.object and place_meeting(x, y+1, Obstacle)) and team == other.team){
                var rdir, vectorfactor;
                rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
                vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25) and (id==other.ownerPlayer.object)
                    continue;
                motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
                if(!ubered and hp > 0)
                {
                    if (id==other.ownerPlayer.object)
                    {
                        hp -= other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                        timeUnscathed = 0;
                        if(id == other.ownerPlayer.object and instance_exists(lastDamageDealer) and lastDamageDealer != other.ownerPlayer)
                        {
                            lastDamageSource = FINISHED_OFF_GIB;
                        }
                        else 
                        {
                            if (lastDamageDealer != other.ownerPlayer && lastDamageDealer != player){
                                secondToLastDamageDealer = lastDamageDealer;
                                alarm[4] = alarm[3]
                            }
                            if (other.ownerPlayer != id)
                                alarm[3] = ASSIST_TIME;
                            lastDamageDealer = other.ownerPlayer;
                            lastDamageSource = other.weapon;
                        }
                        cloakAlpha = max(cloakAlpha, 0.3);
                        cloakFlicker = true;
                        alarm[7] = 3;
                    }
                    if id==other.ownerPlayer.object and other.team == team {
                        moveStatus = 1;
                        speed*=1.06;
                    }
                }
            }
        }

        with (Sentry) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team) {
                    hp -= other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }        
        
        with (Generator) {
            if (distance_to_object(other) < other.blastRadius){
                if(other.team != team) {
                    alarm[0] = regenerationBuffer;
                    isShieldRegenerating = false;
                    //allow overkill to be applied directly to the target
                    var hitDamage;
                    hitDamage = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                    if (hitDamage > shieldHp) {
                        hp -= hitDamage - shieldHp;
                        hp -= shieldHp * shieldResistance;
                        shieldHp = 0;
                    } else {
                        hp -= hitDamage * shieldResistance;
                        shieldHp -= hitDamage;
                    }
                    
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                }
            }
        }
        
        with (DeadGuy) {
          if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
          }
        }
        
        with (Gib) {
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.blastRadius));
                rotspeed=random(151)-75;
            }
        }
    
       // Mines are ignored
        
        with(LooseSheet) {
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
            }
        }
        
        with(Bubble) {
            if (distance_to_object(other) < other.blastRadius*0.66){
                alarm[0]-=200;
            }    
        }

        instance_destroy();
    }
}
")

//Mines ignore other mines and players
object_event_clear(Mine,ev_other,ev_user2)
object_event_add(Mine,ev_other,ev_user2,"
{
    if(exploded == true) {
        exit;
    } else {
        exploded = true;
    }
    instance_create(x,y,Explosion);
    playsound(x,y,ExplosionSnd);
    
    with (Character) {
        if (distance_to_object(other) < other.blastRadius and !(team == other.team and id != other.ownerPlayer.object and place_meeting(x, y+1, Obstacle)) and team == other.team)
        {
            var rdir, vectorfactor;
            rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
            vectorfactor = point_distance(0, 0, sin(degtorad(rdir)), cos(degtorad(rdir))*0.8);
            if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold) and (id==other.ownerPlayer.object) // skip if we're out of theshhold
                continue;
            motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
            if(!ubered and hp > 0)
            {
                var dmg;
                dmg = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                if id == other.ownerPlayer.object// self damage resistance
                    dmg *= 5/9;
                hp -= dmg;
                timeUnscathed = 0;
                if (id == other.ownerPlayer.object and instance_exists(lastDamageDealer) and lastDamageDealer != other.ownerPlayer and !instance_exists(other.reflector))
                    lastDamageSource = FINISHED_OFF_GIB;
                else 
                {
                    if (lastDamageDealer != other.ownerPlayer and lastDamageDealer != player and other.reflector != lastDamageDealer)
                    {
                        secondToLastDamageDealer = lastDamageDealer;
                        alarm[4] = alarm[3]
                    }
                    if (other.ownerPlayer != id or (instance_exists(other.reflector) and other.ownerPlayer == id))
                        alarm[3] = ASSIST_TIME;
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                    if (id==other.ownerPlayer.object and instance_exists(other.reflector))
                    {
                        lastDamageDealer = other.reflector;
                        lastDamageSource = WEAPON_REFLECTED_STICKY;
                    }
                }
                if(global.gibLevel > 0)
                {
                    repeat(3)
                    {
                        var blood;
                        blood = instance_create(x,y,Blood);
                        blood.direction = point_direction(other.x,other.y,x,y)-180;
                    }
                }
                if (id==other.ownerPlayer.object)
                    moveStatus = 1;
            }
            cloakAlpha = max(cloakAlpha, 0.3);
            cloakFlicker = true;
            alarm[7] = 3;
        }
    }

    
    with (Sentry){
        if (distance_to_object(other) < other.blastRadius) && (team != other.team) { 
        hp -= other.explosionDamage*10/9*(1-(distance_to_object(other)/other.blastRadius)); // we want sentries to take ~11% extra damage so that two stickies will do 100 instead of 90 dmg. we don't change the base damage so scouts can't be 2-hitted.
        lastDamageDealer = other.ownerPlayer;
        lastDamageSource = WEAPON_MINEGUN;
        }   
    }    
     
     with (Generator){
        if (distance_to_object(other) < other.blastRadius) && (team != other.team) { 
            alarm[0] = regenerationBuffer;
            isShieldRegenerating = false;
            //allow overkill to be applied directly to the target
            var hitDamage;
            hitDamage = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
            if (hitDamage > shieldHp) {
                hp -= hitDamage - shieldHp;
                hp -= shieldHp * shieldResistance;
                shieldHp = 0;
            } else {
                hp -= hitDamage * shieldResistance;
                shieldHp -= hitDamage;
            }
        }   
    }
       
    // Rockets are ignored
    
    with (DeadGuy) {
        if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
        }
    }
    
    // Mines too
	
    with (Gib) {
        if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.blastRadius));
            rotspeed=random(151)-75;
        }
    }
    
    with(LooseSheet) {
        if (distance_to_object(other) < other.blastRadius){
            motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
        }
    }
    with(Bubble) {
        if (distance_to_object(other) < other.blastRadius*0.66){
        alarm[0]-=200;
        }    
    }

    instance_destroy();
}
")

//END OF CODE
}